//
// Automatically generated file, do not edit.
//

#include "Box.h"

#include "MemLeakFindOn.h"

const char *help_commands[] =
{
	"bbackupquery",
	"list",
	"ls",
	"cd",
	"pwd",
	"lcd",
	"sh",
	"get",
	"compare",
	"restore",
	"getobject",
	"usage",
	"undelete",
	"delete",
	"quit",
	0
};

const char *help_text[] =
{
	"bbackupquery [-q] [-c configfile] [commands ...]\n\n    -q -- quiet, no information prompts\n    -c -- specify another bbackupd configuation file\n\nThe commands following the options are executed, then (if there was no quit\ncommand) an interactive mode is entered.\n\nIf a command contains a space, enclose it in quotes. Example\n\n    bbackupquery \"list testdir1\" quit\n\nto list the contents of testdir1, and then exit without interactive mode.\n",
	"list [options] [directory-name]\n\n    List contents of current directory, or specified directory.\n    \n    -r -- recursively list all files\n    -d -- list deleted files/directories\n    -o -- list old versions of files/directories\n    -I -- don't display object ID\n    -F -- don't display flags\n    -t -- show file modification time\n            (and attr mod time if has the object has attributes, ~ separated)\n    -s -- show file size in blocks used on server\n            (only very approximate indication of size locally)\n\nls can be used as an alias.\n",
	"ls\n\n    Alias for 'list'. Type 'help list' for options.\n",
	"cd [options] <directory-name>\n\n    Change directory\n    \n    -d -- consider deleted directories for traversal\n    -o -- consider old versions of directories for traversal\n        (this option should never be useful in a correctly formed store)\n",
	"pwd\n\n    Print current directory, always root relative.\n",
	"lcd <local-directory-name>\n\n    Change local directory.\n    \n    Type \"sh ls\" to list the contents.\n",
	"sh <shell command>\n\n    All of the parameters after the \"sh\" are run as a shell command.\n    \n    For example, to list the contents of the location directory, type \"sh ls\"\n",
	"get <object-filename> [<local-filename>]\nget -i <object-id> <local-filename>\n\n    Gets a file from the store. Object is specified as the filename within\n    the current directory, and local filename is optional. Ignores old and\n    deleted files when searching the directory for the file to retrieve.\n    \n    To get an old or deleted file, use the -i option and select the object\n    as a hex object ID (first column in listing). The local filename must\n    be specified.\n",
	"compare -a\ncompare -l <location-name>\ncompare <store-dir-name> <local-dir-name>\n\n    Compares the (current) data on the store with the data on the disc.\n    All the data will be downloaded -- this is potentially a very long\n    operation.\n    \n    -a -- compare all locations\n    -l -- compare one backup location as specified in the configuration file.\n    -c -- set return code\n    -q -- quick compare. Only checks file contents against checksums,\n            doesn't do a full download\n    -A -- ignore attribute differences\n    -E -- ignore exclusion settings\n    \n    Comparing with the root directory is an error, use -a option instead.\n\n    If -c is set, then the return code (if quit is the next command) will be\n        1    Comparison was exact\n        2    Differences were found\n        3    An error occured\n    This can be used for automated tests.\n",
	"restore [-drif] <directory-name> <local-directory-name>\n\n    Restores a directory to the local disc. The local directory specified\n    must not exist (unless a previous restore is being restarted).\n\n    The root cannot be restored -- restore locations individually.\n\n    -d -- restore a deleted directory or deleted files inside\n    -r -- resume an interrupted restoration\n    -i -- directory name is actually an ID\n    -f -- force restore to continue if errors are encountered\n\n    If a restore operation is interrupted for any reason, it can be restarted\n    using the -r switch. Restore progress information is saved in a file at\n    regular intervals during the restore operation to allow restarts. \n",
	"getobject <object-id> <local-filename>\n\n    Gets the object specified by the object id (in hex) and stores the raw\n    contents in the local file specified.\n\n    This is only useful for debugging as it does not decode files from the\n    stored format, which is encrypted and compressed.\n",
	"usage [-m]\n\n    Show space used on the server for this account.\n\n    -m -- display the output in machine-readable form\n\n    Used: Total amount of space used on the server.\n    Old files: Space used by old files\n    Deleted files: Space used by deleted files\n    Directories: Space used by the directory structure.\n    \n    When Used exceeds the soft limit, the server will start to remove old and\n    deleted files until the usage drops below the soft limit.\n    \n    After a while, you would expect to see the usage stay at just below the\n    soft limit. You only need more space if the space used by old and deleted\n    files is near zero.\n",
	"undelete <directory-name>\nundelete -i <object-id>\n\n    Removes the deleted flag from the specified directory name (in the\n    current directory) or hex object ID. Be careful not to use this\n    command where a directory already exists with the same name which is\n    not marked as deleted.\n",
	"delete <file-name>\n\n    Sets the deleted flag on the specified file name (in the current\n    directory, or with a relative path).\n",
	"quit\n\n    End session and exit.\n",
	0
};

